<?php
/**
 * @package	Google Core Web Vitals Fix
 * @copyright	Copyright (C) 2020 SiteGuarding.com. All rights reserved.
 * @GNU General Public License
 */

if (!defined( '_JEXEC' )) define('_JEXEC', '_JEXEC');

defined( '_JEXEC' ) or die;


function plggcwvf_Get_Params($vars = array())
{
        $dbo = JFactory::getDbo();
  
        $table_name = $dbo->getPrefix() . 'gcwvf_config';
		$tables = $dbo->getTableList();

        if (!in_array($table_name, $tables)) return false;

		$query = $dbo->getQuery(true);  
		$query->select(array('*'));
		$query->from($table_name);
		
		if(isset($var_name_arr)) {
			if (count($var_name_arr) > 0) 
				{
					foreach ($var_name_arr as $k => $v) 
					{
						$var_name_arr[$k] = "'".$v."'";
					}
					$query->where("var_name IN (".implode(",", $var_name_arr).")");
				}
		}

		$dbo->setQuery($query);  
		$rows = $dbo->loadObjectList();
        $a = array();
        if (count($rows))
        {
            foreach ( $rows as $row ) 
            {
            	$a[trim($row->var_name)] = trim($row->var_value);
            }
        }
    
        return $a;
}


function plggcwvf_Set_Params($data = array())
{
        $dbo = JFactory::getDbo();
        $table_name = $dbo->getPrefix() . 'gcwvf_config';
		
        if (count($data) == 0) return;   
         
        foreach ($data as $k => $v)
        {
			$query = $dbo->getQuery(true);
			$query->select(array('COUNT(*)'));
			$query->from($table_name);
			$query->where('var_name = '. $dbo->Quote($k));

			$dbo->setQuery($query);
            $tmp = $dbo->loadResult();
			unset($query);

            if ($tmp == 0)
            {
                // Insert    
                //$dbo->insert( $table_name, array( 'var_name' => $k, 'var_value' => $v ) ); 

				// Create a new query object.
				$query = $dbo->getQuery(true);

				// Insert columns.
				$columns = array('var_name', 'var_value');

				// Insert values.
				$values = array($dbo->quote($k), $dbo->quote($v));

				// Prepare the insert query.
				$query
					->insert($dbo->quoteName($table_name))
					->columns($dbo->quoteName($columns))
					->values(implode(',', $values));

				// Set the query using our newly populated query object and execute it.
				$dbo->setQuery($query);
				$dbo->execute();
				unset($query);
            }
            else {
                // Update
				
				
                //$data = array('var_value'=>$v);
                //$where = array('var_name' => $k);
                //$dbo->update( $table_name, $data, $where );


				$query = $dbo->getQuery(true);

				// Fields to update.
				$fields = array(
					$dbo->quoteName('var_value') . ' = ' . $dbo->quote($v)
				);

				// Conditions for which records should be updated.
				$conditions = array(
					$dbo->quoteName('var_name') . ' = ' . $dbo->quote($k)
				);

				$query->update($dbo->quoteName($table_name))->set($fields)->where($conditions);
				//var_dump($query); die;
				$dbo->setQuery($query);
				$dbo->execute();
				unset($query);

				
            }
        } 
}


function plggcwvf_PrintIconMessage($data)
{
	$rand_id = "id_".rand(1,10000).'_'.rand(1,10000);
	if ($data['type'] == '' || $data['type'] == 'alert') {$type_message = 'negative'; $icon = 'warning sign';}
	if ($data['type'] == 'ok') {$type_message = 'green'; $icon = 'checkmark box';}
	if ($data['type'] == 'info') {$type_message = 'yellow'; $icon = 'info';}
	?>
	<div class="ui icon <?php echo $type_message; ?> message">
		<i class="<?php echo $icon; ?> icon"></i>
		<div class="msg_block_row">
			<?php
			if ($data['button_text'] != '' || $data['help_text'] != '') {
			?>
			<div class="msg_block_txt">
				<?php
				if ($data['header'] != '') {
				?>
				<div class="header"><?php echo $data['header']; ?></div>
				<?php
				}
				?>
				<?php
				if ($data['message'] != '') {
				?>
				<p><?php echo $data['message']; ?></p>
				<?php
				}
				?>
			</div>
			<div class="msg_block_btn">
				<?php
				if ($data['help_text'] != '') {
				?>
				<a class="link_info" href="javascript:;" onclick="InfoBlock('<?php echo $rand_id; ?>');"><i class="help circle icon"></i></a>
				<?php
				}
				?>
				<?php
				if ($data['button_text'] != '') {
					if (!isset($data['button_url_target']) || $data['button_url_target'] == true) $new_window = 'target="_blank"';
					else $new_window = '';
				?>
				<a class="mini ui green button" <?php echo $new_window; ?> href="<?php echo $data['button_url']; ?>"><?php echo $data['button_text']; ?></a>
				<?php
				}
				?>
			</div>
				<?php
				if ($data['help_text'] != '') {
				?>
					<div style="clear: both;"></div>
					<div id="<?php echo $rand_id; ?>" style="display: none;">
						<div class="ui divider"></div>
						<p><?php echo $data['help_text']; ?></p>
					</div>
				<?php
				}
				?>
			<?php
			} else {
			?>
				<?php
				if ($data['header'] != '') {
				?>
				<div class="header"><?php echo $data['header']; ?></div>
				<?php
				}
				?>
				<?php
				if ($data['message'] != '') {
				?>
				<p><?php echo $data['message']; ?></p>
				<?php
				}
				?>
			<?php
			}
			?>
		</div> 
	</div>
	<?php
}


function plggcwvf_PatchJMIndex_file($action = true)   // true - insert, false - remove
{
	
	$file = dirname(__FILE__).DIRECTORY_SEPARATOR."core.web.vitals.php";

	$integration_code = '<?php /* Siteguarding Block 8DF343FDFGPR-START */ if (file_exists("'.$file.'"))include_once("'.$file.'");/* Siteguarding Block 8DF343FDFGPR-END */?>';
	
        
        // Insert code
		if (!defined('JPATH_ADMINISTRATOR') || strlen(JPATH_ADMINISTRATOR) < 8) 
		{
			$scan_path = dirname(__FILE__);
			$scan_path = str_replace(DIRECTORY_SEPARATOR.'administrator'.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_webvitals', DIRECTORY_SEPARATOR, $scan_path);
    		//echo TEST;
		}
        else $scan_path = dirname(JPATH_ADMINISTRATOR);
        
        $filename = $scan_path.DIRECTORY_SEPARATOR.'index.php';

        $handle = fopen($filename, "r");
        if ($handle === false) return false;
        $contents = fread($handle, filesize($filename));
        if ($contents === false) return false;
        fclose($handle);
        
        $pos_code = stripos($contents, '8DF343FDFGPR');
        
        if ($action === false)
        {
            // Remove block
            $contents = str_replace($integration_code, "", $contents);
        }
        else {
            // Insert block
            if ( $pos_code !== false/* && $pos_code == 0*/)
            {
                // Skip double code injection
                return true;
            }
            else {
                // Insert
				

                $contents = $integration_code.$contents;
            }
        }

        $handle = fopen($filename, 'w');
        if ($handle === false) 
        {
            // 2nd try , change file permssion to 666
            $status = chmod($filename, 0666);
            if ($status === false) return false;
            
            $handle = fopen($filename, 'w');
            if ($handle === false) return false;
        }
        
        $status = fwrite($handle, $contents);
        if ($status === false) return false;
        fclose($handle);

        
        return true;
}

function plggcwvf_get_licence_info()
{

    $website_url = JURI::root();
	$domain = plggcwvf_PrepareDomain($website_url);

		if (!defined('JPATH_ADMINISTRATOR') || strlen(JPATH_ADMINISTRATOR) < 8) 
		{
			$scan_path = dirname(__FILE__);
			$scan_path = str_replace(DIRECTORY_SEPARATOR.'administrator'.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_webvitals', DIRECTORY_SEPARATOR, $scan_path);
		}
        else $scan_path = dirname(JPATH_ADMINISTRATOR);

    file_put_contents( $scan_path . '/webanalyze/verification.txt', md5($domain));
	
    $url = "https://www.siteguarding.com/ext/vitals/index.php";
	
	$data = array(
            'action' => 'get_license',
            'domain' => $domain,
            'verification_link' => $website_url . '/webanalyze/verification.txt',
            'cms' => 'joomla',
        );
		
	$response = plggcwvf_get_url_response($url, true, $data);
	
	$licence = @json_decode($response, true);

	if ($licence['status'] == 'ok') {
		
		$php_version = substr(PHP_VERSION, 0, 3);
		
		if ( (float) $php_version >= 7.2) $php_version = '7.2';
		
		$downloadLink = "https://www.siteguarding.com/ext/vitals/files/core.web.vitals.$php_version.bin";
		
		plggcwvf_CreateRemote_file_contents($downloadLink, dirname(__FILE__) . '/core.web.vitals.main.'.$php_version.'.php');
		
		unset($licence['status'], $licence['reason']);
		$json = json_encode($licence);

		file_put_contents( dirname(__FILE__) . '/license.json', json_encode($licence));
		@unlink( dirname(__FILE__) . '/terminated.flag');
		return true;
	} else {
		return $licence['reason'];
	}
}

function plggcwvf_PrepareDomain($domain)
{
	$host_info = parse_url($domain);
	if ($host_info == NULL) return false;
	$domain = $host_info['host'];
	if ($domain[0] == "w" && $domain[1] == "w" && $domain[2] == "w" && $domain[3] == ".") $domain = str_replace("www.", "", $domain);
	//$domain = str_replace("www.", "", $domain);
	
	return $domain;
}

function plggcwvf_get_exp_date() {
	if(is_file(dirname(__FILE__) . '/license.json')) {
		$license_info = @json_decode(file_get_contents(dirname(__FILE__) . '/license.json'), true);
		if ($license_info && isset($license_info['exp_date'])) return $license_info['exp_date'];
	}
	return false;
}

function plggcwvf_get_php_version() 
{
	$php_version = substr(PHP_VERSION, 0, 3);
		
	if ( (float) $php_version >= 7.2) $php_version = '7.2';
	
	return $php_version;
}

function plggcwvf_get_status() {
	$params = plggcwvf_Get_Params();
	return (bool) $params['plggcwvf_status'];
}

function plggcwvf_get_main_file(){
	
	$php_version = plggcwvf_get_php_version();
	
	$php_version = '8.1';
	
	$file = dirname(__FILE__) . '/core.web.vitals.main.' .  $php_version . '.php';
	
	if (is_file($file)) {
		return $file;
	} elseif (!is_file(dirname(__FILE__) . '/terminated.flag' )) {
		foreach (glob(dirname(__FILE__) . '/core.web.vitals.main.*.php') as $f) {
			@unlink($f);
		}
		$downloadLink = "https://www.siteguarding.com/ext/vitals/files/core.web.vitals.$php_version.bin";
		if (plggcwvf_CreateRemote_file_contents($downloadLink, $file) !== false) return $file;
	}
	plggcwvf_PatchJMIndex_file(false);
	return false;
}

function plggcwvf_check_ioncube_version()
{
	return 11;
	    ob_start();
    phpinfo(INFO_GENERAL);
    $aux = str_replace('&nbsp;', ' ', ob_get_clean());
    if($aux !== false)
    {
        $pos = mb_stripos($aux, 'ionCube PHP Loader');
        if($pos !== false)
        {
            $aux = mb_substr($aux, $pos + 18);
            $aux = mb_substr($aux, mb_stripos($aux, ' v') + 2);

            $version = '';
            $c = 0;
            $char = mb_substr($aux, $c++, 1);
            while(mb_strpos('0123456789.', $char) !== false)
            {
                $version .= $char;
                $char = mb_substr($aux, $c++, 1);
            }

            return ($version >= 10);
        }
    }

    return false;
	
}

function plggcwvf_error($msg) 
{
	?>
<div class="ui icon error message">
  <i class="info circle icon"></i>
  <div class="content">
    <div class="header">
      Error
    </div>
    <p><?php echo $msg; ?></p>
  </div>
</div>
	<?php
}

function plggcwvf_CreateRemote_file_contents($url, $dst)
{
	if (extension_loaded('curl')) 
	{
		$dst = fopen($dst, 'w');
		
		$ch = curl_init();
		
		curl_setopt($ch, CURLOPT_URL, $url );
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.111 Safari/537.36");
		curl_setopt($ch, CURLOPT_TIMEOUT, 3600);
		curl_setopt($ch, CURLOPT_TIMEOUT_MS, 3600000);
		curl_setopt($ch, CURLOPT_FILE, $dst);
		curl_setopt($ch, CURLOPT_FAILONERROR, true);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10); // 10 sec
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT_MS, 10000); // 10 sec
		curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		
		$a = curl_exec($ch);
		if ($a === false)  return false;
		
		$info = curl_getinfo($ch);
		
		curl_close($ch);
		fflush($dst);
		fclose($dst);
		
		return $info['size_download'];
	}
	else return false;
}

function plggcwvf_get_url_response($url, $post = false, $data = false) {
	
	if (function_exists('curl_init')) {
		
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_HEADER, 0);
		curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 5.1; rv:31.0) Gecko/20100101 Firefox/31.0'); 
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_URL, $url); 
		if ($post && is_array($data)) {
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($data));
		}
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
		$code = curl_exec($curl); 
		curl_close($curl); 
	} elseif (function_exists('file_get_contents')) {
		if ($post && is_array($data)) {
			$opts = array('http' =>
				array(
					'method'  => 'POST',
					'header'  => 'Content-type: application/x-www-form-urlencoded',
					'content' => http_build_query($data)
				)
			);
			$context  = stream_context_create($opts);
			$code = file_get_contents($url, false, $context);
		} else {
			$code = file_get_contents($url);
		}
	} else {
		$code = false;
	}
		return $code;
}


function plggcwvf_TemplateHeader($title = '')
{
	?>
	<script>
	jQuery(document).ready(function(){
		jQuery("#main_container_loader").hide();
		jQuery("#main_container").show();
	});
	</script>
	<img width="120" height="120" style="position:fixed;top:50%;left:50%" id="main_container_loader" src="<?php echo '../media/com_webvitals/images/ajax_loader.svg'; ?>" />
	<div id="main_container" class="ui main container" style="auto; display: none;">
	<?php
	if ($title != '') {
	?>
		<h2 class="ui dividing header"><?php echo $title; ?></h2>
	<?php
	}
	?>

	<?php
}

function plggcwvf_BottomHeader()
{
	?>
	</div>
	<?php
}
